{******************************************************************************
 *                                                                            *
 *      THE SEVEN game            Autor: Ing. A. B e n d  k                  *
 *                                                                            *
 ******************************************************************************}
unit MoveCard;

interface

uses
  Windows, Messages, Classes, Controls, Forms, ExtCtrls;

const
  Corner = 4;

type
  TMovingCard = class
    procedure ObjectMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ObjectMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    FImage: TImage;
    FForm: TForm;
    FOwner: TForm;
    FRegion: HRGN;
    _Pozicia: TPoint;
    FIconNumber: Integer;
  public
    constructor Create(AOwner: TForm; const OImage: TImage; const X, Y: Integer); virtual;
    destructor Destroy; override;
  end;

implementation

uses
  Seven_f;

constructor TMovingCard.Create(AOwner: TForm; const OImage: TImage; const X, Y: Integer);
var
  d: TPoint;
  Region: array [0..7] of TPoint;
begin
  inherited Create;
  FOwner := AOwner;
  FIconNumber := OImage.Tag;
  _Pozicia.X := X;
  _Pozicia.Y := Y;

  Region[0].X := Corner;                Region[0].Y := 0;
  Region[1].X := 0;                     Region[1].Y := Corner;
  Region[2].X := 0;                     Region[2].Y := OImage.Height - Corner;
  Region[3].X := Corner;                Region[3].Y := OImage.Height;
  Region[4].X := OImage.Width - Corner; Region[4].Y := OImage.Height;
  Region[5].X := OImage.Width;          Region[5].Y := OImage.Height - Corner;
  Region[6].X := OImage.Width;          Region[6].Y := Corner;
  Region[7].X := OImage.Width - Corner; Region[7].Y := 0;
  FRegion := CreatePolygonRgn(Region, Length(Region), WINDING);

  FForm := TForm.Create(FOwner);
  FForm.BorderStyle := bsNone;
  FForm.FormStyle := fsStayOnTop;
  FForm.OnMouseMove := ObjectMouseMove;
  FForm.OnMouseUp := ObjectMouseUp;
  SetWindowRgn(FForm.Handle, FRegion, True);
  GetCursorPos(d);
  FForm.SetBounds(d.X - _Pozicia.X, d.Y - _Pozicia.Y, OImage.Width, OImage.Height);

  FImage             := TImage.Create(FForm);
  FImage.Parent      := FForm;
  FImage.AutoSize    := True;
  FImage.Picture.Assign(OImage.Picture);

  FForm.Show;
  SetCapture(FForm.Handle);
end;

destructor TMovingCard.Destroy;
begin
  DeleteObject(FRegion);
  inherited Destroy;
end;

procedure TMovingCard.ObjectMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  a, b: Integer;
  Hrana: Integer;
begin
  a := FForm.Left - (_Pozicia.X - X);
  b := FForm.Top - (_Pozicia.Y - Y);
  Hrana := (FOwner.Width - FOwner.ClientWidth) div 2;
  if (a > FOwner.Left + Hrana) and (a + FForm.Width < FOwner.Left + FOwner.Width - 2 * Hrana) then
    FForm.Left := a;
  if (b > FOwner.Top) and (b + FForm.Height < FOwner.Top + FOwner.Height) then
    FForm.Top  := b;
end;

procedure TMovingCard.ObjectMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  PostMessage(FOwner.Handle, WM_CARD_DOWN, FIconNumber, FForm.Top - FOwner.Top);
  SetWindowRgn(FForm.Handle, 0, True);
  FForm.Hide;
  FForm.Free;
  FForm := Nil;
  Free;
  ReleaseCapture;
end;

end.
