{******************************************************************************
 *                                                                            *
 *      THE SEVEN game            Autor: Ing. A. B e n d  k                  *
 *                                                                            *
 ******************************************************************************}

unit seven_f;

interface

{$DEFINE FROMRESOURCE}

uses
  Windows, Graphics, Forms, Messages, SysUtils, StdCtrls, ExtCtrls, Buttons,
  MMSystem, Controls, Menus, ComCtrls, Classes, jpeg;

const
  WM_CARD_DOWN = WM_USER + 1000;
  NUMBEROFCARDS = 32;
  NUMBEROFCARDSONHAND = 4;
  SOUNDS: array [0..2] of PChar = ('Culf.wav', 'Uh.wav', 'Kick.wav');
  SOUNDSRES: array [0..2] of PChar = ('Culf', 'Uh', 'Kick');

  COM_CARDS_LEFT = 26;
  COM_CARDS_TOP = 74;

  PLAYER_CARDS_LEFT = COM_CARDS_LEFT;
  PLAYER_CARDS_TOP = 322;

  CARDS_ON_TABLE_TOP = 205;
  CARDS_ON_TABLE_LEFT = 85;
  MAX_VISIBLE_BUMS = 11;
type
  TFirst = (NoBody, Player, Computer);

  TFour = 1..NUMBEROFCARDSONHAND;

  TNumberOfCards = 0..NUMBEROFCARDS;

  TComputerCards = array [TFour] of TImage;

  TPlayerCards = array [TFour] of TImage;

  TBums = array of TImage;

  TAllCards = set of TNumberOfCards;

  TSevenForm = class (TForm)
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    MainMenu1: TMainMenu;
    New1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    NewGDeal: TMenuItem;
    Turn1: TMenuItem;
    Help1: TMenuItem;
    Exitgame1: TMenuItem;
    AboutTheSevenGame1: TMenuItem;
    N2: TMenuItem;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    HillImage: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Label1: TLabel;
    Label7: TLabel;
    PlayerLabel: TLabel;
    ComputerLabel: TLabel;
    StartButton: TBitBtn;
    Options1: TMenuItem;
    Soundoptions1: TMenuItem;
    NewGDe: TMenuItem;
    Dealround1: TMenuItem;
    Image4: TImage;
    TopHillImage: TImage;
    InfoLabel: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Zanimeodznova1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CardMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CardDblClick(Sender: TObject);
    procedure NextRoundClick(Sender: TObject);
    procedure Exitgame1Click(Sender: TObject);
    procedure Turn1Click(Sender: TObject);
    procedure Autor1Click(Sender: TObject);
    procedure Soundoptions1Click(Sender: TObject);
    procedure AboutTheSevenGame1Click(Sender: TObject);
    procedure NewGDealClick(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure Zanimeodznova1Click(Sender: TObject);
  private
    IniFile: String;
    PlayerSound,
    ComputerSound,
    TakeCardSound: Byte;
    ActualScore: Byte; // skre v aktulnom kole ...
    SetOfAllCards: array [1..8] of TAllCards; // mnoiny vetkch skupn kariet ...
    PlayerBumCount, // poet holt potaovch ...
    ComputerBumCount: Integer; // poet holt hrovch ...
    PlayerBum, // odkazy na zadky ...
    ComputerBum: TBums; // odkazy na karty ...
    Bum: TBitmap; // zadok
    CardsOnTable: Byte; // poet kariet na stole ...
    CardsInHill: Byte; // poet kariet v kope ...
    LastFirst, // kto by mal s ako prv po poslednej hre ...
    First: TFirst; // kto ide ako (mal by) prv ...
    Sound: Boolean; // i vbec pa zvuk ...
    LastCard, // posledn karta na stole - potaova alobo hrova ...
    FirstCard: TNumberOfCards; // ktor karta bola prv v kole ...
    Hill: array [1..NUMBEROFCARDS] of TNumberOfCards; // pomiean karty v kope
    ComputerCard,
    PlayerCard: TComputerCards;
    EightCard, NineCard, JackCard, QueenCard, KingCard, KillCard, AceCard,
    TenCard: TAllCards; // mnoiny sel bitmp pre skupiny kariet ...
    ComputerCardsOnHand, // aktulne karty na rukch ...
    PlayerCardsOnHand: array [TFour] of TNumberOfCards;
    AllGivenCards: array of TNumberOfCards; // pole danch kariet na stole ....
    procedure NewGame(const Speach: String = '');
    procedure Moved(var Message: TMessage); message WM_CARD_DOWN;
    procedure PutCardOnTable(const Card: TImage; const CardNumber: TNumberOfCards);
    procedure TakeCardsFromHill(Cards: Byte);
    procedure AddBum(BumFor: TFirst);
    procedure AddBums(BumFor: TFirst; Number: Integer);
    procedure FreeBums;
    procedure ReadInfo;
    procedure WriteInfo;
    procedure ShowForm(Form: TFormClass);
    procedure ChangeCard(CardNumber, ImageNumber: Byte);
    procedure ForbideCards(Card: TNumberOfCards); // zake udalos onmousedown kartm, ktor v momentlnom kole nie su povolen!
    procedure ComputerGives;
    procedure TakeCardsForNextRound(Enable: Boolean; All: Boolean = False);
    function IsForScore(Card: TNumberOfCards): Boolean;
    function NextRound: Boolean;  // True - pokrauje sa ...
    function GiveLastInfo: TFirst;
    function WasKilled(Card: TNumberOfCards): Boolean;
    procedure SetInfo(const Info: String);
    procedure PlayCardSound(SoundIndex: Integer);    
  end;

var
  SevenForm: TSevenForm;

implementation

uses
  HeadSeven_f, Finish_f, Options_f, InfoForm_f, MoveCard, seven_library;

{$R *.DFM}
{$IFDEF FROMRESOURCE}
{$R cards.res}
{$R sound.res}
{$ENDIF}

procedure TSevenForm.ShowForm(Form: TFormClass);
begin
  with Form.Create(Nil) do
  try
    ShowModal;
  finally
    Release;
  end
end;

procedure TSevenForm.TakeCardsFromHill(Cards: Byte);
begin
  if CardsInHill > 0 then
  begin
    HillImage.Top := HillImage.Top - Cards * Corner;
    Dec(CardsInHill, Cards);
  end;
  if CardsInHill = 0 then
  begin
    HillImage.Visible := False;
    TopHillImage.Visible := False;
  end;
end;

procedure TSevenForm.ChangeCard(CardNumber, ImageNumber: Byte);
var
  CardName: String;
begin
  {$IFNDEF FROMRESOURCE}
  CardName := IntToStr(CardNumber) + '.bmp';
  if CardNumber <= 9 then
    CardName := '0' + CardName;
  {$ELSE}
  CardName := IntToStr(CardNumber);
  if CardNumber <= 9 then
    CardName := '_0' + CardName
  else
    CardName := '_' + CardName;
  {$ENDIF}
  try
    case ImageNumber of
      0: PlayerCard[ImageNumber].Picture.Assign(HillImage.Picture);
      {$IFNDEF FROMRESOURCE}
      1..4: PlayerCard[ImageNumber].Picture.LoadFromFile(CardName);
      5..8: ComputerCard[ImageNumber - 4].Picture.LoadFromFile(CardName);
      {$ELSE}
      1..4: PlayerCard[ImageNumber].Picture.Bitmap.LoadFromResourceName(HINSTANCE, CardName);
      5..8: ComputerCard[ImageNumber - 4].Picture.Bitmap.LoadFromResourceName(HINSTANCE, CardName);
      {$ENDIF}
    end;
  except
    on E: EFOpenError do
      raise Exception.Create(INFO_ERROR1 + ' ' + CardName + '.');
  end
end;

procedure TSevenForm.ForbideCards(Card: TNumberOfCards);
var
  i, j: Byte;
begin
  for i := 2 to 8 do
    if Card in SetOfAllCards[i] then
      break;
  for j := 1 to NUMBEROFCARDSONHAND do
    if not((PlayerCardsOnHand[j] in SetOfAllCards[i]) or (PlayerCardsOnHand[j] in KillCard))
      and (PlayerCardsOnHand[j] <> 0)
    then begin
      PlayerCard[j].OnClick := Nil;
      PlayerCard[j].OnDblClick := Nil;
      PlayerCard[j].OnMouseDown := Nil;
    end;
end;

procedure TSevenForm.FormCreate(Sender: TObject);
var
  i: Integer;
  TopHill: TBitMap;
  Speach: String;
begin
  Caption := Application.Title;
  StartButton.Hint := INFO_1;
  InfoLabel.Caption := INFO_2;
  Label2.Caption := InfoLabel.Caption;
  Label1.Caption := INFO_3;
  Label7.Caption := INFO_4;  

  LastFirst := NoBody;
  PlayerBumCount := 0;
  ComputerBumCount := 0;

  Application.HintColor := clLime;
  Application.HintHidePause := 5000;
  for i := 0 to Application.ComponentCount - 1 do
    if Application.Components[i] is THintWindow then
      with THintWindow(Application.Components[i]).Canvas do begin
        Font.Name := 'Mans Serif';
        Font.Size := 12;
        Font.Style:= [fsBold, fsItalic];
        break;
      end;

  IniFile := ChangeFileExt(ExtractFileName(Application.ExeName), '.ini');
  ReadInfo;

  Bum := TBitmap.Create;
  {$IFNDEF FROMRESOURCE}
  Bum.LoadFromFile('bum.bmp');
  {$ELSE}
  Bum.LoadFromResourceName(HINSTANCE, 'bum');
  {$ENDIF}

  {$IFNDEF FROMRESOURCE}
  HillImage.Picture.Bitmap.LoadFromFile('00.bmp');
  {$ELSE}
  HillImage.Picture.Bitmap.LoadFromResourceName(HINSTANCE, '_00');
  {$ENDIF}
  Image10.Picture.Assign(HillImage.Picture);
  Image11.Picture.Assign(HillImage.Picture);
  Image12.Picture.Assign(HillImage.Picture);
  Image13.Picture.Assign(HillImage.Picture);
  TopHill := TBitmap.Create;
  try
    TopHill.Width := HillImage.Picture.Bitmap.Width;
    TopHill.Height := HillImage.Picture.Bitmap.Height;
    TopHill.Canvas.Brush.Color := Color;
    TopHill.Canvas.FillRect(TopHill.Canvas.ClipRect);
    TopHill.Canvas.Brush.Color := clWhite;
    TopHill.Canvas.RoundRect(0, 0, TopHill.Width, TopHill.Height, 11, 11);
    for i := 1 to 24 do
    begin
      TopHill.Canvas.MoveTo(0, i * Corner);
      TopHill.Canvas.LineTo(Corner, (i - 1) * Corner);
      TopHill.Canvas.LineTo(TopHill.Width - Corner, (i - 1) * Corner);
      TopHill.Canvas.LineTo(TopHill.Width, i * Corner);
    end;
    TopHillImage.Picture.Bitmap.Assign(TopHill);
  finally
    TopHill.Free;
  end;

  PlayerCard[1]   := Image1;
  PlayerCard[2]   := Image2;
  PlayerCard[3]   := Image3;
  PlayerCard[4]   := Image4;
  ComputerCard[1] := Image5;
  ComputerCard[2] := Image6;
  ComputerCard[3] := Image7;
  ComputerCard[4] := Image8;

  KillCard  := [1, 9,17,25];
  EightCard := [2,10,18,26];
  NineCard  := [3,11,19,27];
  TenCard   := [4,12,20,28];
  JackCard  := [5,13,21,29];
  QueenCard := [6,14,22,30];
  KingCard  := [7,15,23,31];
  AceCard   := [8,16,24,32];

  SetOfAllCards[1] := KillCard;
  SetOfAllCards[2] := EightCard;
  SetOfAllCards[3] := NineCard;
  SetOfAllCards[4] := TenCard;
  SetOfAllCards[5] := JackCard;
  SetOfAllCards[6] := QueenCard;
  SetOfAllCards[7] := KingCard;
  SetOfAllCards[8] := AceCard;

  AddBums(Player, PlayerBumCount);
  AddBums(Computer, ComputerBumCount);

  NewGame(Speach);
end;

procedure TSevenForm.FormDestroy(Sender: TObject);
begin
  WriteInfo;
  Bum.Free;
  FreeBums;
end;

procedure TSevenForm.Exitgame1Click(Sender: TObject);
begin
  Close
end;

procedure TSevenForm.NewGame(const Speach: String = '');

  procedure  MixCards;
  var
    Number, Check, i: TNumberOfCards;
    Found: Boolean;
  begin
    for i := 1 to NUMBEROFCARDS do
      Hill[i] := 0;
    Check := 1;
    Hill[1] := 1 + Random(NUMBEROFCARDS);
    while Check < NUMBEROFCARDS do
    begin
      Found := False;
      Number := 1 + Random(NUMBEROFCARDS);
      for i := 1 to NUMBEROFCARDS do
        if Hill[i] = Number then
        begin
          Found := True;
          break
        end;
      if not Found then
      begin
        Inc(Check);
        Hill[Check] := Number;
      end;
    end;
  end;

var
  i: TFour;
begin
  if ComputerLabel.Tag >= 60 then
    First := Computer
  else if PlayerLabel.Tag >= 60 then
    First := Player
  else
    First := LastFirst;

  ActualScore := 0;
  FirstCard := 0;
  LastCard := 0;
  CardsOnTable := 0;
  CardsInHill := 24;
  PlayerLabel.Caption := '0';
  PlayerLabel.Tag := 0;
  ComputerLabel.Caption := '0';
  ComputerLabel.Tag := 0;
  TopHillImage.Visible := True;
  HillImage.Visible := True;
  Image10.Visible := False;
  Image11.Visible := False;
  Image12.Visible := False;
  Image13.Visible := False;
  Dealround1.Enabled := False;
  New1.Enabled := False;

  MixCards;
  for i := 1 to NUMBEROFCARDSONHAND do
  begin
    PlayerCardsOnHand[i] := Hill[i];
    ChangeCard(Hill[i], i);
    if not PlayerCard[i].Visible then
      PlayerCard[i].Visible := True;
    PlayerCard[i].OnMouseDown := CardMouseDown;
    PlayerCard[i].OnMouseMove := Nil;
    PlayerCard[i].OnDblClick := CardDblClick;
    ComputerCardsOnHand[i] := Hill[i + 4];
    ChangeCard(0, i + 4);
    if not ComputerCard[i].Visible then
      ComputerCard[i].Visible := True;
  end;

  StatusBar1.Panels[0].Text := Format(INFO_CARDSINHILL, [24]);
  StatusBar1.Panels[1].Text := Format(INFOS_CORE, [PlayerBumCount, ComputerBumCount]);

  for i := 1 to NUMBEROFCARDSONHAND do
  begin
    PlayerCard[i].SetBounds(PLAYER_CARDS_LEFT + 68 * (i - 1), PLAYER_CARDS_TOP,
      PlayerCard[i].Width, PlayerCard[i].Height);
    ComputerCard[i].SetBounds(PlayerCard[i].Left, COM_CARDS_TOP,
      ComputerCard[i].Width, ComputerCard[i].Height);
  end;

  if Speach <> '' then
    SetInfo(Speach)
  else
  case First of
    Player: SetInfo(Concat(InfoLabel.Caption, ' ', INFO_GOFIRST));
    Computer: SetInfo(Concat(InfoLabel.Caption, ' ', INFO_SECOND));
    NoBody: SetInfo(INFO_ANYONE);
  end;

  StartButton.Enabled := True;
  HillImage.Top := 260;
  TakeCardsForNextRound(False);
  SetLength(AllGivenCards, 0);

  if not Turn1.Enabled then
  begin
    NewGDe.Enabled := False;
    NewGDeal.Enabled := False;
    Zanimeodznova1.Enabled := False;
  end;
end;

procedure TSevenForm.Turn1Click(Sender: TObject);
var
  i: TFour;
begin
  for i := 1 to NUMBEROFCARDSONHAND do
    if ComputerCardsOnHand[i] <> 0 then
      ChangeCard(ComputerCardsOnHand[i], i + 4);
end;

procedure TSevenForm.AddBum(BumFor: TFirst);
var
  i: Integer;
  TempArray: TBums;
  Count: ^Integer;
begin
  if BumFor = Player then
  begin
    TempArray := Copy(ComputerBum, 0, Length(ComputerBum));
    Count := @PlayerBumCount;
  end
  else
  begin
    TempArray := Copy(PlayerBum, 0, Length(PlayerBum));
    Count := @ComputerBumCount;
  end;
  if Length(TempArray) < MAX_VISIBLE_BUMS then
  begin
    SetLength(TempArray, Length(TempArray) + 1);
    i := High(TempArray);
    TempArray[i] := TImage.Create(Self);
    TempArray[i].Parent := Self;
    TempArray[i].Width := 40;
    TempArray[i].Height := 40;
    TempArray[i].Transparent := True;
    TempArray[i].ShowHint := True;
    TempArray[i].Left := i * Bum.Width;
    if BumFor = Player then
    begin
      TempArray[i].Top := ClientHeight - Bum.Height - StatusBar1.Height;
      TempArray[i].Hint := INFO_PLAYERS_SCORE;
    end else
      TempArray[i].Hint := INFO_COMPUTERS_SCORE;
    TempArray[i].Picture.Bitmap.Assign(Bum);
  end;
  if BumFor = Player then
    ComputerBum := Copy(TempArray, 0, Length(TempArray))
  else
    PlayerBum := Copy(TempArray, 0, Length(TempArray));
  Inc(Count^);
  SetLength(TempArray, 0);
end;

procedure TSevenForm.AddBums(BumFor: TFirst; Number: Integer);
var
  i: Integer;
  TempArray: TBums;
begin
  if BumFor = Player then
  begin
    if Number > MAX_VISIBLE_BUMS then
      SetLength(ComputerBum, MAX_VISIBLE_BUMS)
    else
      SetLength(ComputerBum, Number);
    TempArray := Copy(ComputerBum, 0, Length(ComputerBum));
    PlayerBumCount := Number;
  end
  else
  begin
    if Number > MAX_VISIBLE_BUMS then
      SetLength(PlayerBum, MAX_VISIBLE_BUMS)
    else
      SetLength(PlayerBum, Number);
    TempArray := Copy(PlayerBum, 0, Length(PlayerBum));
    ComputerBumCount := Number;
  end;

  for i := 0 to High(TempArray) do
  begin
    TempArray[i] := TImage.Create(Self);
    TempArray[i].Parent := Self;
    TempArray[i].Width := 40;
    TempArray[i].Height := 40;
    TempArray[i].Transparent := True;
    TempArray[i].ShowHint := True;
    TempArray[i].Left := i * Bum.Width;
    if BumFor = Player then
    begin
      TempArray[i].Top := ClientHeight - Bum.Height - StatusBar1.Height;
      TempArray[i].Hint := INFO_PLAYERS_SCORE;
    end else
      TempArray[i].Hint := INFO_COMPUTERS_SCORE;
    TempArray[i].Picture.Bitmap.Assign(Bum);
  end;

  if BumFor = Player then
    ComputerBum := Copy(TempArray, 0, Length(TempArray))
  else
    PlayerBum := Copy(TempArray, 0, Length(TempArray));
end;

procedure TSevenForm.FreeBums;
var
  i: Integer;
begin
  for i := 0 to High(PlayerBum) do
    PlayerBum[i].Free;
  SetLength(PlayerBum, 0);
  PlayerBumCount := 0;
  for i := 0 to High(ComputerBum) do
    ComputerBum[i].Free;
  SetLength(ComputerBum, 0);
  ComputerBumCount := 0;
end;

procedure TSevenForm.Autor1Click(Sender: TObject);
begin
  ShowForm(THeadForm)
end;

procedure TSevenForm.Soundoptions1Click(Sender: TObject);
begin
  with TOptionsForm.Create(Self) do
  try
    PlayerRadioGroup.ItemIndex := PlayerSound;
    ComputerRadioGroup.ItemIndex := ComputerSound;
    SystemRadioGroup.ItemIndex := TakeCardSound;
    CheckBox2.Checked := Sound;
    if ShowModal = mrOk then
    begin
      PlayerSound := PlayerRadioGroup.ItemIndex;
      ComputerSound := ComputerRadioGroup.ItemIndex;
      TakeCardSound := SystemRadioGroup.ItemIndex;
      Sound := CheckBox2.Checked;
    end;
  finally
    Release;
  end;
end;

procedure TSevenForm.AboutTheSevenGame1Click(Sender: TObject);
begin
  ShowForm(TInformationForm)
end;

procedure TSevenForm.CardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (not (ssDouble in Shift)) and (Button = mbLeft) then
    TImage(Sender).OnMouseMove := CardMouseMove;
end;

procedure TSevenForm.CardMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  TImage(Sender).Visible := False;
  TMovingCard.Create(Self, TImage(Sender), X, Y);
end;

procedure TSevenForm.CardMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TImage(Sender).OnMouseMove := Nil;
end;

procedure TSevenForm.Moved(var Message: TMessage);
begin
  with Message do
  begin
    PlayerCard[WParam].OnMouseMove := Nil;
    if LParam < Bevel1.Top + GetSystemMetrics(SM_CYMENU) + StatusBar1.Height then
    begin // premiestnen ...
      SetInfo('');
      PutcardOnTable(PlayerCard[WParam], PlayerCardsOnHand[WParam]);
      if CardsOnTable = 1 then
      begin
        FirstCard := PlayerCardsOnHand[WParam];
        First := Player;
        ForbideCards(FirstCard);
        StartButton.Enabled := False;
      end;
      LastCard := PlayerCardsOnHand[WParam];
      PlayerCard[WParam].Visible := True;
      PlayerCardsOnHand[WParam] := 0;
      PlayCardSound(PlayerSound);
      ComputerGives;
    end else
      PlayerCard[WParam].Visible := True;
  end;
end;

procedure TSevenForm.PutCardOnTable(const Card: TImage; const CardNumber: TNumberOfCards);
begin
  Card.SetBounds(CARDS_ON_TABLE_LEFT + CardsOnTable * (Card.Width div 2),
    CARDS_ON_TABLE_TOP, Card.Width, Card.Height);
  Inc(CardsOnTable);
  if IsForScore(CardNumber) then
    Inc(ActualScore, 10);
  SetLength(AllGivenCards, Length(AllGivenCards) + 1);
  AllGivenCards[High(AllGivenCards)] := CardNumber;
  Card.OnMouseDown := Nil;
  Card.OnMouseMove := Nil;
  Card.BringToFront;
end;

procedure TSevenForm.ComputerGives;

  function GiveFirstCardInNewGame: TFour;
  var
    Max, i, j: Byte;
    TempArray: array [TFour] of Byte;
    TempMaxArray: array [TFour] of Byte;
  begin
    // naplnenie pola mnozinami ...
    for i := 1 to NUMBEROFCARDSONHAND do
      for j := 1 to 8 do
        if ComputerCardsOnHand[i] in SetOfAllCards[j] then
        begin
          TempArray[i] := j;
          break;
        end;
    // ziskanie indexu pola, ktoreho polozka sa v nom nachadza najviac ...
    for i := 1 to NUMBEROFCARDSONHAND do
      TempMaxArray[i] := 1;
    for i := 1 to 3 do
      for j := i + 1 to NUMBEROFCARDSONHAND do
        if TempArray[i] = TempArray[j] then
          Inc(TempMaxArray[i]);
    Max := 1;
    for i := 1 to NUMBEROFCARDSONHAND do
      if TempMaxArray[i] > Max then
        Max := i;
    // Pokial nie je treba, sedmu nie ....
    if ComputerCardsOnHand[Max] in KillCard then
    begin
      Max := 0;
      for i := 1 to NUMBEROFCARDSONHAND do
        if not (ComputerCardsOnHand[i] in KillCard) then
        begin
          Max := i;
          break;
        end;
      if Max = 0 then
        Result := 1
      else
        Result := Max;
    end
    else
      Result := Max;
  end;

  function GiveFirstCardInNextRound: TFour;
  var
    Max, i, j, k: Byte;
    TempArray: array [TFour] of Byte;
    TempMaxArray: array [TFour] of Byte;
  begin
    // naplnenie pola mnozinami ...
    for i := 1 to NUMBEROFCARDSONHAND do
    begin
      if ComputerCardsOnHand[i] = 0 then
        TempArray[i] := 0
      else
        for j := 1 to 8 do
          if ComputerCardsOnHand[i] in SetOfAllCards[j] then
          begin
            TempArray[i] := j;
            break;
          end;
    end;
    // ziskanie indexu pola, ktoreho polozka sa v nom nachadza najviac ...
    for i := 1 to NUMBEROFCARDSONHAND do
      if TempArray[i] = 0 then
        TempMaxArray[i] := 0
      else
        TempMaxArray[i] := 1;
    for i := 1 to 3 do
      for j := i + 1 to NUMBEROFCARDSONHAND do
        if (TempArray[i] <> 0) and (TempArray[i] = TempArray[j]) then
          Inc(TempMaxArray[i]);

    // pamtanie si vyhodench kariet ...
    for i := 1 to NUMBEROFCARDSONHAND do
    begin
      if TempArray[i] <> 0 then
        for j := 0 to High(AllGivenCards) do
          for k := 1 to 8 do
            if (AllGivenCards[j] in SetOfAllCards[k]) and
              (k = TempArray[i]) then
            begin
              Inc(TempMaxArray[i]);
              break;
            end;
    end;

    // maximum ...
    Max := 0;
    for i := 1 to NUMBEROFCARDSONHAND do
      if TempMaxArray[i] > Max then
        Max := i;

    j := Max;
    // Pokial nie je treba, sedmu nie ....
    if (Max > 0) and (ComputerCardsOnHand[Max] in KillCard) then
    begin
      Max := 0;
      for i := 1 to NUMBEROFCARDSONHAND do
        if (ComputerCardsOnHand[i] <> 0) and not (ComputerCardsOnHand[i] in KillCard) then
        begin
          Max := i;
          break;
        end;
        if Max = 0 then
          Result := j
        else
          Result := Max;
    end else
      Result := Max;

    if Result = 0 then // Daj hociktoru
      for i := 1 to NUMBEROFCARDSONHAND do
        if ComputerCardsOnHand[i] <> 0 then
        begin
          Result := i;
          break;
        end;
  end;

  // vrati index karty na pocitacovaj ruke, ktoru by mal pocitac pretocit alebo zabit ....
  function FindNextCard: Byte;
  var
    i, j: Byte;
  begin
    Result := 0;
    for i := 2 to 8 do
      if FirstCard in SetOfAllCards[i] then
        break;
    for j := 1 to NUMBEROFCARDSONHAND do
      if (ComputerCardsOnHand[j] <> 0) and (ComputerCardsOnHand[j] in SetOfAllCards[i]) then
      begin
        Result := j;
        break;
      end;
  end;

  // funkcia vrati index karty sedmy, ak sa na ruke pocitaca nachadza ...
  function FindNextSevenCard: Byte;
  var
    i: TFour;
  begin
    Result := 0;
    for i := 1 to NUMBEROFCARDSONHAND do
      if (ComputerCardsOnHand[i] <> 0) and (ComputerCardsOnHand[i] in KillCard) then
      begin
        Result := i;
        break;
      end;
  end;

  // funkcia vrati index hociktorej karty, ktora je volna ...
  function FindAnyCard: Byte;
  var
    i: TFour;
  begin
    Result := 0;
    for i := 1 to NUMBEROFCARDSONHAND do // ak netreba, tak nemasti ...
      if (ComputerCardsOnHand[i] <> 0) and not IsForScore(ComputerCardsOnHand[i]) then
      begin
        Result := i;
        break;
      end;
    if Result = 0 then
      for i := 1 to NUMBEROFCARDSONHAND do
        if ComputerCardsOnHand[i] <> 0 then begin
          Result := i;
          break;
        end;
  end;

  function IsForBonus: Boolean; // ci je na spodu mast
  begin
    Result := (FirstCard in TenCard) or (FirstCard in AceCard);
  end;

var
  Index: Byte;
begin
  if Length(AllGivenCards) = NUMBEROFCARDS then
  begin
    TakeCardsForNextRound(True);
    exit;
  end;

  if Length(AllGivenCards) = 0 then
  begin // ak ide pota prv v novej hre ...

    Index := GiveFirstCardInNewGame;
    FirstCard := ComputerCardsOnHand[Index];
    ComputerCardsOnHand[Index] := 0;
    ChangeCard(FirstCard, Index + 4);
    PutCardOnTable(ComputerCard[Index], FirstCard);
    StartButton.Enabled := False;
    First := Computer;
    LastCard := FirstCard;
    TakeCardsForNextRound(False);
    SetInfo(INFO_ADD);

  end else if First = Computer then
  begin
    if FirstCard = 0 then
    begin // pota ide prv v novom kole ...

      Index := GiveFirstCardInNextRound;
      FirstCard := ComputerCardsOnHand[Index];
      ComputerCardsOnHand[Index] := 0;
      ChangeCard(FirstCard, Index + 4);
      PutCardOnTable(ComputerCard[Index], FirstCard);
      LastCard := FirstCard;
      TakeCardsForNextRound(False);
      SetInfo(INFO_ADD);

    end
    else if not WasKilled(LastCard) then
    begin

      // ak je naspodu mas, alebo hr dal mas, netoi ...
      if IsForBonus or IsForScore(LastCard) then
      begin

        TakeCardsForNextRound(True, True);
        SetInfo(INFO_COMP_TAKES);

      end
      else
      begin // ak m, nech zato ...
        Index := FindNextCard; // ale nie sedmu
        if Index <> 0 then
        begin // Zatoi so upou ...

          LastCard := ComputerCardsOnHand[Index];
          ComputerCardsOnHand[Index] := 0;
          ChangeCard(LastCard, Index + 4);
          PutCardOnTable(ComputerCard[Index], LastCard);
          TakeCardsForNextRound(False);
          SetInfo(INFO_ADD);

        end
        else
        begin

          TakeCardsForNextRound(True, True);
          SetInfo(INFO_COMP_TAKES);

        end;
      end;
    end
    else
    begin // treba asi zabi ...
      Index := FindNextCard; // ale nie sedmu ak nie je treba ...
      if Index <> 0 then
      begin // Zatoi so upou ...

        LastCard := ComputerCardsOnHand[Index];
        ComputerCardsOnHand[Index] := 0;
        ChangeCard(LastCard, Index + 4);
        PutCardOnTable(ComputerCard[Index], LastCard);
        TakeCardsForNextRound(False);
        SetInfo(INFO_ADD);

      end else if IsForBonus then
      begin // ak je naspodu mas, zabi sedmou...
        Index := FindNextSevenCard;
        if Index <> 0 then
        begin

          LastCard := ComputerCardsOnHand[Index];
          ComputerCardsOnHand[Index] := 0;
          ChangeCard(LastCard, Index + 4);
          PutCardOnTable(ComputerCard[Index], LastCard);
          TakeCardsForNextRound(False);
          SetInfo(INFO_COMP_TAKES);

        end
        else
        begin

          SetInfo(INFO_TAKEHILL);
          TakeCardsForNextRound(True, True);

        end;
      end
      else
      begin  // ak naspodu nie je mas, i zabi sedmou...

        Index := FindNextSevenCard;
        if Index <> 0 then
        begin

          LastCard := ComputerCardsOnHand[Index];
          ComputerCardsOnHand[Index] := 0;
          ChangeCard(LastCard, Index + 4);
          PutCardOnTable(ComputerCard[Index], LastCard);
          TakeCardsForNextRound(False);
          SetInfo(INFO_ADD);

        end
        else
        begin

          SetInfo(INFO_TAKEHILL);
          TakeCardsForNextRound(True, True);

        end;
      end;
    end;
  end
  else
  begin // pota dva ako druh ...

    Index := FindNextCard;
    if Index = 0 then
    begin
      if not Image11.Visible or not Image12.Visible or IsForBonus then
        Index := FindNextSevenCard;
      if Index = 0 then
      begin
        Index := GiveFirstCardInNextRound;
        if IsForScore(ComputerCardsOnHand[Index]) then
          Index := FindAnyCard;
        SetInfo(INFO_TAKE);
      end
      else
        SetInfo(INFO_COMP_TAKES);
    end
    else
      SetInfo(INFO_COMP_TAKES);

    LastCard := ComputerCardsOnHand[Index];
    ComputerCardsOnHand[Index] := 0;
    ChangeCard(LastCard, Index + 4);
    PutCardOnTable(ComputerCard[Index], LastCard);
    TakeCardsForNextRound(True);
  end;
end;

// Funkcia urci ci karta kopu zabila alebo nie ...
function TSevenForm.WasKilled(Card: TNumberOfCards): Boolean;
var
  i: Byte;
begin
  for i := 1 to 8 do
    if FirstCard in SetOfAllCards[i] then
      break;
  Result := (Card in SetOfAllCards[i]) or (Card in KillCard);
end;

procedure TSevenForm.NextRoundClick(Sender: TObject);
begin
  SetInfo('');
  PlayCardSound(TakeCardSound);
  NextRound;
  if Length(AllGivenCards) = NUMBEROFCARDS then
  begin
    if GiveLastInfo = Computer then
    begin
      First := Computer;
      NewGame;
      ComputerGives;
    end;
  end
  else if First = Computer then
    ComputerGives;
end;

procedure TSevenForm.NewGDealClick(Sender: TObject);
begin
  NewGame;
end;

procedure TSevenForm.Zanimeodznova1Click(Sender: TObject);
begin
  FreeBums;
  ComputerLabel.Tag := 0;
  PlayerLabel.Tag := 0;
  First := NoBody;
  LastFirst := NoBody;
  NewGame;
end;

procedure TSevenForm.StartButtonClick(Sender: TObject);
begin
  ComputerGives;
  PlayCardSound(ComputerSound);
end;

function TSevenForm.IsForScore(Card: TNumberOfCards): Boolean;
begin
  Result := (Card in TenCard) or (Card in AceCard);
end;

function TSevenForm.NextRound: Boolean;
var
  i, j, k, Half: Byte;
begin
  if First = Player then
  begin
    if WasKilled(LastCard) then
      First := Computer;
  end else if First = Computer then
  begin
    if WasKilled(LastCard) then
      First := Player;
  end;

  if First = Computer then
  begin
    ComputerLabel.Tag := ComputerLabel.Tag + ActualScore;
    ComputerLabel.Caption := IntToStr(ComputerLabel.Tag);
    if not Image10.Visible then
    begin
      Image10.Visible := True;
      Image11.Visible := True;
    end;
  end else if First = Player then
  begin
    PlayerLabel.Tag := PlayerLabel.Tag + ActualScore;
    PlayerLabel.Caption := IntToStr(PlayerLabel.Tag);
    if not Image12.Visible then
    begin
      Image12.Visible := True;
      Image13.Visible := True;
    end;
  end;

  for i := 1 to NUMBEROFCARDSONHAND do
  begin
    PlayerCard[i].OnDblClick := CardDblClick;
    PlayerCard[i].OnMouseDown := CardMouseDown;
    if PlayerCardsOnHand[i] = 0 then
      PlayerCard[i].SetBounds(PLAYER_CARDS_LEFT + 68 * (i - 1), PLAYER_CARDS_TOP,
        PlayerCard[i].Width, PlayerCard[i].Height);
    if ComputerCardsOnHand[i] = 0 then
      ComputerCard[i].SetBounds(PlayerCard[i].Left, COM_CARDS_TOP,
        ComputerCard[i].Width, ComputerCard[i].Height);
  end;

  if CardsInHill > 0 then
  begin
    j := NUMBEROFCARDS - CardsInHill;
    if CardsOnTable <= CardsInHill then
    begin
      for i := 1 to NUMBEROFCARDSONHAND do
        if ComputerCardsOnHand[i] = 0 then
        begin
          Inc(j);
          ComputerCardsOnHand[i] := Hill[j];
          ChangeCard(0, i + 4);
        end;
      for i := 1 to NUMBEROFCARDSONHAND do
        if PlayerCardsOnHand[i] = 0 then
        begin
          Inc(j);
          PlayerCardsOnHand[i] := Hill[j];
          ChangeCard(Hill[j], i);
        end;
    end
    else
    begin
      CardsOnTable := CardsInHill;
      Half := CardsInHill div 2;
      k := 0;
      for i := 1 to NUMBEROFCARDSONHAND do
        if ComputerCardsOnHand[i] = 0 then
        begin
          Inc(j);
          Inc(k);
          ComputerCardsOnHand[i] := Hill[j];
          ChangeCard(0, i + 4);
          if k = Half then
            break;
        end;
      k := 0;
      for i := 1 to NUMBEROFCARDSONHAND do
        if PlayerCardsOnHand[i] = 0 then
        begin
          Inc(j);
          Inc(k);
          PlayerCardsOnHand[i] := Hill[j];
          ChangeCard(Hill[j], i);
          if k = Half then
            break;
        end;
    end;
  end;

  for i := 1 to NUMBEROFCARDSONHAND do
  begin
    if ComputerCardsOnHand[i] = 0 then
      ComputerCard[i].Visible := False
    else if not ComputerCard[i].Visible then
      ComputerCard[i].Visible := True;
    if PlayerCardsOnHand[i] = 0 then
      PlayerCard[i].Visible := False
    else if not PlayerCard[i].Visible then
      PlayerCard[i].Visible := True;
  end;

  TakeCardsFromHill(CardsOnTable);
  CardsOnTable := 0;
  FirstCard := 0;
  ActualScore := 0;
  LastCard := 0;
  TakeCardsForNextRound(True);
  StatusBar1.Panels[0].Text := Format(INFO_CARDSINHILL, [CardsInHill]);
  if (Length(AllGivenCards) < NUMBEROFCARDS) and (First = Player) then
    SetInfo(INFO_GO);
  Result := Length(AllGivenCards) < NUMBEROFCARDS;
end;

procedure TSevenForm.TakeCardsForNextRound(Enable: Boolean; All: Boolean = False);
var
  i: TFour;
  SomeEvent: TNotifyEvent;
begin
  Dealround1.Enabled := Enable;
  New1.Enabled := Enable;

  if Enable then
    SomeEvent := NextRoundClick
  else
    SomeEvent := Nil;

  HillImage.OnClick := SomeEvent;
  TopHillImage.OnClick := SomeEvent;
  Image5.OnClick := SomeEvent;
  Image6.OnClick := SomeEvent;
  Image7.OnClick := SomeEvent;
  Image8.OnClick := SomeEvent;
  Image10.OnClick := SomeEvent;
  Image11.OnClick := SomeEvent;
  Image12.OnClick := SomeEvent;
  Image13.OnClick := SomeEvent;

  if Enable then
  begin
    for i := 1 to NUMBEROFCARDSONHAND do
      if PlayerCardsOnHand[i] = 0 then // iba tie, ktor s na stole ...
        PlayerCard[i].OnClick := NextRoundClick
      else
      begin
        PlayerCard[i].OnClick := Nil;
        if All then
        begin
          PlayerCard[i].OnDblClick := Nil;
          PlayerCard[i].OnMouseDown := Nil;
        end;
      end
  end
  else
  begin
    for i := 1 to NUMBEROFCARDSONHAND do
      PlayerCard[i].OnClick := Nil;
  end;
end;

function TSevenForm.GiveLastInfo: TFirst;
begin
  Result := LastFirst;
  Dealround1.Enabled := False;
  New1.Enabled := False;
  case ComputerLabel.Tag of
    0:      begin
              Result := Player;
              if Image11.Visible then
                SetInfo(INFO_YOUWIN)
              else begin
                SetInfo(INFO_YOUWIN_OK);
                AddBum(Player);
              end;
            end;
    10..30: begin
              SetInfo(INFO_YOUWIN);
              if ComputerLabel.Tag < 30 then
                Result := Player;
            end;
    40:     SetInfo(INFO_GOON);
    50..70: begin
              SetInfo(INFO_YOULOOSE);
              if ComputerLabel.Tag >= 60 then
                Result := Computer;
            end;
    else begin
      if Image12.Visible then
        SetInfo(INFO_YOULOOSE)
      else begin
        SetInfo(INFO_YOULOOSE_TOTAL);
        AddBum(Computer);
      end;
      Result := Computer;
    end;
  end;
  LastFirst := Result;
  if not NewGDe.Enabled then begin
    NewGDe.Enabled := True;
    NewGDeal.Enabled := True;
    Zanimeodznova1.Enabled := True;
  end;
end;

procedure TSevenForm.SetInfo(const Info: String);
begin
  InfoLabel.Caption := Info;
  Label2.Caption := Info;
end;

procedure TSevenForm.CardDblClick(Sender: TObject);
begin
  SendMessage(Handle, WM_CARD_DOWN, (Sender as TImage).Tag, PLAYER_CARDS_TOP - 100);
end;

procedure TSevenForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: Close;
    VK_RETURN: if Assigned(HillImage.OnClick) then
                 HillImage.OnClick(Nil);
    else if (ssShift in Shift) and Assigned(HillImage.OnClick) then
           HillImage.OnClick(Nil);
  end;
end;

procedure TSevenForm.ReadInfo;
begin
  with TStringList.Create do
  try
    try
      if FileExists(IniFile) then
        LoadFromFile(IniFile)
      else begin
        Position := poScreenCenter;
        Sound := True;
        PlayerSound := 2;
        ComputerSound := 0;
        TakeCardSound := 1;
      end;
    except
      on E: EFOpenError do
        raise Exception.Create(INFO_ERROR2 + ' ' + IniFile);
    end;
    Left := StrToIntDef(Values['Left'], 50);
    Top := StrToIntDef(Values['Top'], 50);
    Sound := Boolean(StrToIntDef(Values['Sound'], Integer(True)));
    PlayerSound := StrToIntDef(Values['PlayerSound'], 2);
    ComputerSound := StrToIntDef(Values['ComputerSound'], 0);
    TakeCardSound := StrToIntDef(Values['TakeCardSound'], 1);
    ComputerBumCount := StrToIntDef(Values['ComputerBumCount'], 0);
    PlayerBumCount := StrToIntDef(Values['PlayerBumCount'], 0);
  finally
    Free
  end
end;

procedure TSevenForm.WriteInfo;
begin
  with TStringList.Create do
  try
    Values['Left'] := IntToStr(Left);
    Values['Top'] := IntToStr(Top);
    Values['Sound'] := IntToStr(Integer(Sound));
    Values['PlayerSound'] := IntToStr(PlayerSound);
    Values['ComputerSound'] := IntToStr(ComputerSound);
    Values['TakeCardSound'] := IntToStr(TakeCardSound);
    Values['ComputerBumCount'] := IntToStr(ComputerBumCount);
    Values['PlayerBumCount'] := IntToStr(PlayerBumCount);
    try
      SaveToFile(IniFile);
    except
      on E: EWriteError do
        raise Exception.Create(INFO_ERROR3 + ' ' + IniFile);
    end;
  finally
    Free
  end
end;

procedure TSevenForm.PlayCardSound(SoundIndex: Integer);
begin
  if Sound then
  {$IFNDEF FROMRESOURCE}
    PlaySound(SOUNDS[SoundIndex], HINSTANCE, SND_ASYNC);
  {$ELSE}
    PlaySound(SOUNDSRES[SoundIndex], HINSTANCE, SND_ASYNC or SND_RESOURCE);
  {$ENDIF}
end;

procedure TSevenForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  FairPlay: Boolean;
begin
  with TFinishForm.Create(Nil) do
  try
    BitBtn2.TabOrder := 0;
    BitBtn1.TabOrder := 1;
    FairPlay := (First = Computer) and (not Image13.Visible);
    if FairPlay then 
      Label1.Caption := INFO_WANTEND;
    CanClose := ShowModal = mrOK;
    if CanClose and FairPlay then
      Inc(ComputerBumCount);
  finally
    Release;
  end;
end;

initialization
  Randomize;
end.
